; --- I/O BASE ADDRESS ---

INTBASE	EQU	H'FFFF8348	; INTC BASE ADDRESS
MTUBASE	EQU	H'FFFF8200	; MTU BASE ADDRESS
CMTBASE	EQU	H'FFFF83D0	; CMT BASE ADDRESS

; --- WORK AREA ADDRESS ---

RAMWAV	EQU	H'FFFFE000	; WAVEFORM DATA(128 BYTES * 8)
MCHTBL	EQU	H'FFFFE400	; MUSIC CH WORK(64BYTES * 8)
TONTBL	EQU	H'FFFFE600	; TONE DATA(8BYTES * 16)
MUSPQ	EQU	H'FFFFE680	; PLAY POINTER QUE(LONGWORD * 9 * 4)
BASBAS	EQU	H'FFFFE710	; BASIC TEXT BASE ADDRESS

; --- ERROR CODE ---

CMXSYN	EQU	1		; CODE OF MML SYNTAX ERROR
CMXILL	EQU	2		; CODE OF MML ILLEGAL FC
CMXOCT	EQU	3		; CODE OF MML OCTAVE OUT
CMXBDL	EQU	4		; CODE OF MML BAD LENGTH

; --- OFFSET OF MUSIC CH WORKAREA ---

; FOR ENVELOPE GENERATOR

MCHEST	EQU	0	; ENV.STATE(0..4)
MCHVOL	EQU	1	; VOLUME(0..255)
MCHAR	EQU	2	; ATTACK RATE(127..32767)
MCHDR	EQU	4	; DECAY RATE(-127..-32767)
MCHSL	EQU	6	; SUSTAIN LEVEL(0..32767)
MCHSR	EQU	8	; SUSTAIN RATE(257:FAST 511:SLOW 512:NO EXP.)
MCHRR	EQU	10	; RR(256:FAST 511:SLOW)
MCHEV1	EQU	12	; ENV.LEVEL BEFOR VOLUME(0..32767)
MCHEV2	EQU	14	; ENV.LEVEL AFTER VOLUME(0..32767)

; FOR OSCRATOR

MCHFRQ	EQU	16	; FREQ
MCHFAC	EQU	18	; FREQ ACCUM
MCHWAD	EQU	20	; WAVETABLE BASE ADDRESS
MCHWV	EQU	24	; WAVE VALUE BEFOR E.G.(-127..127)
;		26	; FILLER

; FOR SEQUENSOR

MCHOCT	EQU	28	; OCTAVE(0..9)
MCHGTM	EQU	29	; GATE TIME(1..16)
MCHLEN	EQU	30	; DEFAULT LENGTH
MCHGTR	EQU	32	; GATE TIMER
MCHNTR	EQU	34	; NOTE TIMER
; 32..63		; RESERVE
MCHSIZ	EQU	64
